unit ausnahme;

interface

uses dialogs,objects,drivers,views;

type
  PAusnahmeListBox = ^TAusnahmeListBox;
  TAusnahmeListBox = object(TListBox)
    constructor Init(var Bounds: TRect; ANumCols: Word; AScrollBar:PScrollBar);
    destructor done; virtual;
    procedure HandleEvent(var Event: TEvent); virtual;
    function GetText(Item: Integer; MaxLen: Integer): String; virtual;
    procedure Insert;
    procedure InsertTrustee;
    procedure Edit;
    procedure Delete;
    procedure recalc;
  end;

procedure ShowAusnahme;

implementation

uses app,msgbox,
     nwmisc,nwfile,
     global,nwiproc,tvutil,auscalc;


{ ############ TAusnahmeListBox ################## }

constructor TAusnahmeListBox.Init(var Bounds: TRect; ANumCols: Word; AScrollBar:PScrollBar);
begin
  inherited init(Bounds,ANumCols,AScrollBar);
  list:=ausnahmelist;
  setrange(list^.count);
  drawview;
end;

destructor TAusnahmeListBox.done;
begin
  {dispose(list,done);  }
  inherited done;
end;

procedure TAusnahmeListBox.HandleEvent(var Event: TEvent);

  procedure MyEvents(Event:TEvent);
  begin
    case event.what of
      evKeydown:
        case Event.keycode of
          kbIns: Insert;
          kbDel: Delete;
          kbEnter: Edit;
          else exit;
        end;
      evCommand:
        case Event.Command of
          cmAusnahmeRecalc: {recalc};
        else exit;
        end;
    {  evBroadCast:
        case Event.keycode of
          else exit;
        end;}
      else exit;
    end;
    clearevent(event);
  end;

begin
  myevents(Event);
  inherited HandleEvent(Event);
end;

function TausnahmeListBox.GetText(Item: Integer; MaxLen: Integer): String;
begin
  GetText:=TAusnahme(list^.at(item)^).GetText(MaxLen);
end;

procedure TausnahmeListBox.Insert;
{$I aus_wahl.src }
var d:PDialog;
begin
  d:=makedialog;
  d^.options := d^.options or ofcentered;
  datarec.wahl:=0;
  if application^.executeDialog(d,@datarec) = cmOk then
    begin
      case datarec.wahl of
        0: InsertTrustee;
      end;
    end;
end;

procedure TausnahmeListBox.InsertTrustee;
var Aus:PAusnahme;
    path:string;
    rights:word;
begin
  if GetTrusteeBox(Path,rights) then
    begin
{      Aus:=new(PAusnahme,init);
      with aus^.data do
        begin
          typ:=0;
          trustee_path:=path;
          trustee_rights:=rights;
        end;
      list^.insert(aus);
      setrange(list^.count);
      drawview;}
    end;
end;

procedure TausnahmeListBox.Edit;
var aus:Pausnahme;
begin
  if list^.count = 0 then exit;
{  aus:=pausnahme(list^.at(focused));
  case aus^.data.typ of
    0: EditTrustee;
  end;}
end;

procedure TausnahmeListbox.delete;
begin
  if list^.count > 0 then
    if messagebox('Wirklich lschen?',nil,mfConfirmation+mfOkCancel) = cmOK then
      begin
        list^.atfree(focused);
        setrange(list^.count);
        drawview;
      end;
end;

procedure TAusnahmeListBox.recalc;
begin
  list^.freeall;
  {AusnahmeCalc(list);}
  setrange(list^.count);
  drawview;
end;


{ ##########  Procedures ############## }

procedure ShowAusnahme;
{$I ausnahme.src }
var d:PDialog;
begin
  d:=makedialog;
  d^.options := d^.options or ofcentered;
  desktop^.insert(d);
end;

end.